﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LifeLogApp.Model
{
    public class LifeLogEvent
    {
        // https://business.adobe.com/blog/basics/project-management-101-the-5-ws-and-1-h-that-should-be-asked-of-every-project
        // When did it take place?
        // Where  did it take place?
        // What happened?
        // Why did it happen?
        // Who  is it about?


        public LifeLogEvent()
        {
            Version = "1";
        }

        public string Version { get; private set; }

        public Guid LifeLogEventId { get; set; }

        public string WhoOrUserIdOrEmail { get; set; }

        public string FolderOrProject { get; set; }
        public string SubFolderOrSubProject { get; set; }

        public DateTime WhenOrTimeUTC { get; set; }
        public DateTime WhenOrTimeLocal => WhenOrTimeUTC.ToLocalTime();

        public Location WhereLocation { get; set; }
        public string WherePlace { get; set; }

        public string WhatOrHowOrWhyOrEventOrAction { get; set; }

        public List<string> Tags { get; set; }
        public string TagFirst => Tags?.FirstOrDefault("") ?? "";

        public string LocalMediaFullFileName { get; set; }
        public string FileName => Path.GetFileName(LocalMediaFullFileName);
        public string FileNameWithoutExtension => Path.GetFileNameWithoutExtension(LocalMediaFullFileName);
        public string MediaType => Path.GetExtension(LocalMediaFullFileName);
        public bool LocalMediaIsRotatedOrPostFixed { get; set; }
    }
}
